#define STRICT
#include <stdlib.h>	// ltoa
#include <string.h>	// strchr
#include <windows.h>
#include <windowsx.h>


/*******************
 * Hilfsfunktionen *
 *******************/

// Erzeugt (C-migen) String aus Byte-Kette
// Puffer drfen sich nicht berlappen
static void escape(char *d, const char *s, int len, BOOL mit) {
 char c;
 for (; len; len--, s++) {
  c=*s;
  if (mit) {
   switch (c) {
    case '\r': c='r'; break;
    case '\n': c='n'; break;
    case '\a': c='a'; break;
    case '\b': c='b'; break;
    case '\t': c='t'; break;
    case 27:   c='e'; break;
   }
   if (c!=*s || c=='\\' || c=='^') d+=wsprintf(d,"\\%c",c);
   else if ((unsigned char)c<' ') d+=wsprintf(d,"\\x%02X",(unsigned char)c);
   else *d++=c;
  }else if ((unsigned char)c>' ') *d++=c;
 }
 *d=0;
}

// Erzeugt Byte-Kette aus nullterminiertem String
// Verarbeitet Backslash-Kodes (C), ^-Kodes (Terminal), %-Ersetzung (C) fr Iteration
// Puffer drfen sich berlappen, max. 256 Bytes
static int unescape
(char*d, const char *src,long Iteration) {
 char b[256],c,*s;
 int n=0;			// Bytezhler
 wsprintf(b,src,Iteration);
 s=b;
 for(;;){
  switch (c=*s++) {
   case 0: return n;
   case '\\': {
    switch (c=*s++) {		// nchstes Zeichen interpretieren
     case 0: return n;
     case 'r': c='\r'; break;
     case 'n': c='\n'; break;
     case 'a': c='\a'; break;
     case 'b': c='\b'; break;
     case 't': c='\t'; break;
     case 'e': c=27; break;	// Escape
     case 'x': {
      char *p=s+2,r=*p;*p=0;	// Nach 2 Zeichen abhacken
      c=strtol(s,&s,16);	// Hexadezimal (auch 0 erlaubt!)
      *p=r;
     }break;
     default: if ('0'<=c && c<='7') {
      char *p=s+2,r=*p;*p=0;	// Nach 3 Zeichen abhacken
      c=strtol(s-1,&s,8);	// Oktal (auch 0 erlaubt!)
      *p=r;
     }
     // Alle anderen Folgezeichen unverndert durchlassen
    }
   }break;
   case '^': c=*s++-'@';	// nchstes Zeichen - 0x40 (auch 0 erlaubt!)
  }
  *d++=c; n++;
 }
}

// Die Funktion strstr(Heuhaufen,Nadel), aber mit mglichen Null-Bytes
static const char* memmem(const char*h, int hl, const char*n, int nl) {
 const char *he=h+hl;		// Ende des Heuhaufens (unvernderlich)
 if (nl>hl) return NULL;
 if (!nl) return h;
 while ((h=memchr(h,*n,he-h))!=0) {	// 1. Zeichen der Nadel suchen
  if (!memcmp(h,n,nl)) return h;	// Rest vergleichen
  h++;					// Ab nchstes Byte im Heuhaufen
 }
 return NULL;
}

// Text an Editfeld anhngen, dabei Benutzer-Markierung behalten(!?)
// (ist ein oft gesehener, geradezu klassischer Bug, aber wie war denn die Lsung?)
static void AppendText(HWND Wnd, const char *s) {
// DWORD sel=Edit_GetSel(Wnd);
 Edit_SetSel(Wnd,-1,-1);	// Null-Markierung (Kursor) am Ende 
 Edit_ReplaceSel(Wnd,s);	// Ersetzen = anhngen
// if (sel) Edit_SetSel(Wnd,LOWORD(sel),HIWORD(sel));
}

/******************
 * Rattermaschine *
 ******************/

int CommId=-1;	// >=0 wenn Programm luft

static void StopTerm(HWND Wnd) {
 char b[2];
 if (CommId>=0) CloseComm(CommId);
 CommId=-1;
 KillTimer(Wnd,1);
 GetDlgItemText(Wnd,114,b,sizeof(b));
 SetDlgItemText(Wnd,1,*b!='0'?"W&eiter":"&Start");
}

static void StartIterate(HWND);

#pragma argsused
static void CALLBACK EndIterate(HWND Wnd, UINT Msg, UINT id, DWORD Time) {
 int bl,el;
 BOOL weiter;
 long Iteration;
 char b[512],e[4096];

 KillTimer(Wnd,id);			// nichtperiodisch

 GetDlgItemText(Wnd,114,b,sizeof(b));
 Iteration=strtol(b,NULL,0);		// Iteration um 1 erhhen
 wsprintf(e,"%ld",Iteration+1);		// (fngt C-mig mit 0 an)
 SetDlgItemText(Wnd,114,e);

 el=ReadComm(CommId,e,sizeof(e));
 lstrcat(b,": ");
 if (el) {
  int ell=el;
  if (ell>64) ell=64;			// Log-Lnge begrenzen
  lstrcat(b,"");
  if (ell!=el) lstrcat(b,"...");	// Verkrzungsvorgang anzeigen
  escape(b+lstrlen(b),e+el-ell,ell,IsDlgButtonChecked(Wnd,115));
  lstrcat(b,"");
 }else lstrcat(b,"Keine Antwort");
 lstrcat(b,"\r\n");
 AppendText(GetDlgItem(Wnd,127),b);	// Gelesenen String anzeigen


 GetDlgItemText(Wnd,113,b,sizeof(b));
 bl=unescape(b,b,Iteration);		// Suchstring als Byte-Kette

 weiter=memmem(e,el,b,bl)?TRUE:FALSE;	// Nadel (b) im Heuhaufen (e) gefunden?
 weiter^=IsDlgButtonChecked(Wnd,130);

 if (weiter) StartIterate(Wnd);		// je nachdem weitermachen oder abbrechen
 else StopTerm(Wnd);
}

static void StartIterate(HWND Wnd) {
 int l;
 WORD to;
 long Iteration;
 char b[256];
 GetDlgItemText(Wnd,114,b,sizeof(b));
 Iteration=strtol(b,NULL,0);
 GetDlgItemText(Wnd,111,b,sizeof(b));
 l=unescape(b,b,Iteration);
 WriteComm(CommId,b,l);
 to=GetDlgItemInt(Wnd,112,NULL,FALSE);
 SetTimer(Wnd,1,to,EndIterate);
}

static void StartTerm(HWND Wnd) {
 char *p, b[128];
 GetDlgItemText(Wnd,110,b,sizeof(b));
 p=strchr(b,':');
 if (p) *p=0;		// abhacken
 CommId=OpenComm(b,4096,256);
 if (CommId<0) {
  MessageBox(Wnd,"Fehler beim ffnen der seriellen Schnittstelle!",NULL,0);
  return;
 }
 if (p) {
  DCB dcb;
  GetCommState(CommId,&dcb);
  *p=':';		// zurckpatchen
  if (BuildCommDCB(b,&dcb)<0 || SetCommState(&dcb)<0) {
   MessageBox(Wnd,"Fehler beim Verarbeiten der Schnittstellenparameter!",NULL,0);
   StopTerm(Wnd);
   return;
  }
 }
 SetDlgItemText(Wnd,1,"&Stopp");
 StartIterate(Wnd);
}

int gCmdShow;

#pragma argsused
static BOOL CALLBACK DlgProc(HWND Wnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
#define WM_CONTINUEINIT WM_USER+10

 switch (Msg) {

  case WM_INITDIALOG: {
   ShowWindow(Wnd,gCmdShow);
   PostMessage(Wnd,WM_CONTINUEINIT,0,0);
  }return TRUE;

  case WM_CONTINUEINIT: {
   UpdateWindow(Wnd);
// Vorgaben laden (zu tun!)
   CheckDlgButton(Wnd,131,TRUE);
  }break;

  case WM_COMMAND: {
   switch (wParam) {
    case IDOK: {	/* Start/Weiter/Stop */
     if (CommId>=0) StopTerm(Wnd); else StartTerm(Wnd);
    }break;
    case IDCANCEL: {
// Vorgaben retten (zu tun!)
     EndDialog(Wnd,2);
    }break;

    case 114: switch (HIWORD(lParam)) {	// Edit-Fenster
     case EN_CHANGE: if (CommId<0) StopTerm(Wnd); break;	// Knopfbeschriftung anpassen
    }


    case 127: switch (HIWORD(lParam)) {	// Log-Fenster (kann berlaufen)
     case EN_ERRSPACE:
     case EN_MAXTEXT: SetWindowText((HWND)lParam,""); break;	// leeren
    }

   }
  }break;
 }
 return FALSE;
#undef WM_CONTINUEINIT
}

#pragma argsused
int PASCAL WinMain(HINSTANCE HInstance, HINSTANCE HPrevInst,
  LPSTR lpCmdLine, int nCmdShow) {
 gCmdShow=nCmdShow;
 return DialogBox(HInstance,MAKEINTRESOURCE(100),0,DlgProc);
}
